### Adding an Controller

Once we have the **Data-Project** we could expose it via an Controller (called **API-Project**)

Here is the test

```coffee
Api_Project = require '../../src/controllers/Api-Project'

describe 'controllers | Api-Project', ->
  api_Project = null

  before ->
    using new Api_Project(), ->
      api_Project = @

  it 'constructor', ->
    using api_Project, ->
      @.constructor.name.assert_Is 'Api_Project'      
      @.data_Project.constructor.name.assert_Is 'Data_Project'
      @.router.assert_Is_Function()

  it 'add_Routes', ()->
    using new Api_Project(), ->
      @.add_Routes()
      @.router.stack.assert_Size_Is 1

  it 'list', ()->
    res =
      json: (data)->
        data.assert_Contains ['demo', 'appsec']

    using new Api_Project(), ->
      @.list(null, res)
```

Here is the code

```coffee
Data_Project  = require '../backend/Data-Project'
express       = require 'express'

class Api_Project
  constructor: (options)->
    @.options      = options || {}
    @.router       = express.Router()
    @.data_Project = new Data_Project()

  add_Routes: ()=>
    @.router.get '/project/list'     , @.list
    @

  list: (req,res)=>
    res.json @.data_Project.projects_Keys()

module.exports = Api_Project
```
