## Leanpub book, originally based on Blog posts

This book started with the AngularJS related blog posts published on [my blog](http://blog.diniscruz.com) and eventually evolved into the book you have in your hands (or eReader).

The idea to use my blog posts was to:

* kickstart the creation of this book (and provide a number of chapters that could be further improved)
* capture the multiple experiments and learning curves that I experienced (while learning how to use AngularJS)
* provide a 'real world' point of view on how to learn and use AngularJS

The theme of this book is **'Practical'** (hence the name 'Practical AngularJS'), and what I am trying to do here is to show how to use these technologies in practical situations, specially how to apply them to solve real problems. This means that sometimes the end result is a bit messy, with lots of rabbit-holes/tangents followed (and un-followed). But that is how it works. When learning a new technology, what is really important is to experiment a lot, and see how it works for the problem we have at hand.

### An open book, freely available at GitHub

My objective with this book is to share knowledge and to help others (as I have been helped by numerous other online resources)

If you are reading this on your eReader, please visit https://github.com/DinisCruz/Book_Practical_AngularJS for a full hyperlinked copy of the content AND (more importantly) the code samples used in the book.

This repository contains the full source materials that are used to create the version [available at Leanpub](https://leanpub.com/Practical_AngularJS) which can be downloaded for free, or paid for using the dynamic 'how much do you want to pay' slider. These fees help to cover the costs of creating this book, so if you bought the book, THANK YOU, if you haven't, then it would be great if you could help a bit (assuming you liked and learned from this book).

I'm also using the GitHub's Issues ([see here](https://github.com/DinisCruz/Book_Practical_AngularJS/issues)) to manage the work items, ideas and bugs/problems with the content/code-samples.

Please use it if you want to provide any ideas, fixes or contributions to this book.

Finally, note that this book is still in a 'draft release status' with lots of content and fixes to be added.

I can be contacted directly at dinis.cruz@owasp.org (note that sometimes I'm not very good with my email, so don't be shy to resend your email/question multiple times :)  )



### Notes about current structure

The first version of this book had the chapter order created by the original ‘import from blogger’ (i.e. by publish order).

Next, the posts were split into the following areas: "Using AngularJS", "KarmaJS", "Firebase", "Misc Tricks", "IDEs", "Troubleshooting", "Appendices", which were a filter based on technology.

At the moment I'm working/thinking about the best way to structure this content, and how to present it in a easy to read/consume format.

It would be great if you (the reader) could provide some feedback on the book's structure, for example:

* if you think the book's order should be different (or chapters renamed)
* there is content missing (really important to cover in an AngularJS book)
* a particular chapter is not very clear, easy-to-understand or relevant
* etc...


### About the Author

Dinis Cruz is a Developer and Application Security Engineer focused on how to develop secure applications. A key drive is on 'Automating Application Security Knowledge and Workflows' which is the main concept behind the OWASP O2 Platform and the FluentSharp APIs.

After many years (and multiple roles) Dinis is still very active at OWASP, currently leading the OWASP O2 Platform project and helping out other projects and initiatives.

After failing to scale his own security knowledge, learned Git, created security vulnerabilities in code published to production servers, delivered training to developers, and building multiple CI (Continuous Integration) environments; Dinis had the epiphany that the key to application security is "Secure Continuous Delivery: Developer's Immediate Connection to What They're Creating". This 'Immediate Connection/Feedback' concept is deep rooted in the development of the O2 Platform, and is something that will keep Dinis busy for many years.
