## Debugging a weird case of missing module in AngularJS and KarmaJS

When I was trying the  [Running KarmaJS's AngularJS example test/e2e/angular-scenario (on Chrome)](http://blog.diniscruz.com/2013/06/running-karmas-angularjs-example.html) I hit on the the following weird behavior.

TLDR; the solution was to run **npm install --g karma@canary**  

**Setup**  

Chrome window opened in:

![](images/debugging-weird-1.png)

... a local website at port 8000:

![](images/debugging-weird-2.png)

... which is a nodeJS powered website, started using **_node server.js_** (below)

![](images/debugging-weird-3.png)

A simple (as I could make it)**_ Karma.config.js_** file

![](images/debugging-weird-4.png)

.... and AngularJS test

![](images/debugging-weird-5.png)   

**Scenario A) Running from folder with karma clone (and npm install)**  

    karma start ..\angular-scenario\karma.conf.js

works OK

![](images/image_thumb_25255B16_25255D.png)

**Scenario B) running from parent folder**  

    karma start angular-scenario\karma.conf.js

fails with a **_module is not defined error_**  

![](images/image_thumb_25255B17_25255D1.png)

So what I think is happening is that because I run**_ npm install_** on the karma folder (the one I got from a GitHub clone), there are more modules in there than in the global karma (which I got when I installed karma using **_npm install --g karma_**)

At the moment there are 49 modules in the GitHub karma:

![](images/image_thumb_25255B21_25255D1.png)

And 20 modules in the global karma install

![](images/image_thumb_25255B19_25255D1.png)

So let's try running npm install on this folder

![](images/image_thumb_25255B23_25255D1.png)

![](images/image_thumb_25255B22_25255D1.png)

And now there are 33 modules installed:

![](images/image_thumb_25255B25_25255D1.png)

but that still didn't work :(

At this stage I remembered reading something about installing the latest version of karma (globally), which is probably what I'm getting from the github clone, and that could explain the different number of modules.

So I executed **_npm install --g karma@canary_**  
![](images/image_thumb_25255B26_25255D1.png)

which installed ok:  

![](images/image_thumb_25255B27_25255D1.png)

Now running the **scenario B)** case throws a different error:

![](images/image_thumb_25255B28_25255D1.png)

It looks that we also need install the **_karma-ng-scenario_** module

![](images/image_thumb_25255B29_25255D1.png)

And now it works :)

![](images/image_thumb_25255B30_25255D1.png)
